# pd02.py (coding: cp932)
  # sΕUɊւF̊֐Ƃ̗p
  # g̕sΕUɂāAjɗLӍ邩
import os, sys
import pandas as pd
import numpy as np
import scipy.stats as stats

from platform import python_version
if int(python_version()[0]) < 3:  # python ver 2 ̏ꍇ
    reload(sys)
    sys.setdefaultencoding('cp932')  # ftHgR[hύX

# \̂̒`(F̌ʂɋL^)
from collections import namedtuple
FtestRes = namedtuple("FtestRes", "f p_value alt var df")

# F: alternative="two-sided", "less", "greater"
def var_test(a, b, alternative="two-sided"):
    alt_arg = alternative
    aa = np.array(a)
    bb = np.array(b)
    aa_var = np.var(aa, ddof=1)  # a̕sΕU
    bb_var = np.var(bb, ddof=1)  # b̕sΕU
    aa_df = len(aa) - 1  # a̎Rx
    bb_df = len(bb) - 1  # b̎Rx
    f = aa_var / bb_var  # F̒l
    pval1 = stats.f.cdf(f, aa_df, bb_df)  # БplÊP
    pval2 = stats.f.sf(f, aa_df, bb_df)  # БplÊQ
    pval3 = min(pval1, pval2) * 2  # pl
    if alt_arg == 'less':
        alt = u"Η: قƂF䂪 1.0 菬."
        pval = pval1
    elif alt_arg == 'greater':
        alt = u"Η: قƂF䂪 1.0 傫."
        pval = pval2
    elif alt_arg == 'two-sided':
        alt = u"Η: قƂF䂪 1.0 ƓȂ."
        pval = pval3
    else:
        alt = "3 p_values(less, greater, two-sided)"
        pval = [pval1, pval2, pval3]
    fr = FtestRes(f, pval, alt, [aa_var, bb_var], [aa_df, bb_df])
    return fr

xls_file = "pt_source.xls"
dtf = pd.read_excel(xls_file)
dgb = dtf.groupby(u'')  # jʂɕ

dct = {u'g': dict(), u'̏d': dict()}
for key in dct.keys():  # ugȀdvꂼ
    for g_name, g_dtf in dgb:  # ujAvɐ؂蕪
        ser = g_dtf[key]
        dct[key][g_name] = ser.dropna().reset_index(drop=True)

male = dct[u'g'][u'j']
female = dct[u'g'][u'']
fr = var_test(male, female, alternative="two-sided")
for key in fr._fields:
    print("%s = " % key + str(fr._asdict()[key]))
